#!/usr/bin/perl
##############################################################################
# SimpleMail Config File.       See $ver for build.                          #
# Copyright 2003 MarkeTrends    mrt@marketrends.net                          #
# Created 04/18/00              Last Modified 06/21/04                       #
#                                                                            #
#              Support: http://www.marketrends.net/maillist/                 #
##############################################################################
#
# TERMS OF USE 
# 1. SimpleMail is offered as shareware.  In exchange
# for its use, MarkeTrends requires the following:
#
# Customer/User may use/install SimpleMail as many
# times as customer wishes, as long as customer owns the web
# site that SimpleMail is installed on.  
# SimpleMail may not under any circumstances be sold
# or redistributed without the written consent of MarkeTrends and 
# its owner Matt Tourtillott.
#
# 2. MarkeTrends Productions, at its own discresion, will decide if any terms 
# of the this agreement have been violated by customer. Upon written e- 
# mailed notification to Customer of Terms of Use violations, 
# MarkeTrends may revoke customer's license to use SimpleMail
#
# In that event, Customer agrees to any and all of the following:
#
# a) Customers found in violation of this agreement, found reselling or
# redistributing SimpleMail, will no longer be licensed to 
# use SimpleMail and agrees to either immediately cease
# the use/distribution of SimpleMail.
# 
# b). Customer will no longer be licensed to run any version of 
# SimpleMail 
#
# Indemnification
# 1. Customer agrees that it shall defend, indemnify, save and hold
# MarkeTrends Productions Web Hosting and marketing, and any
# persons affiliated with either company, harmless from any and all
# demands, liabilities, losses, costs and claims, including reasonable
# attorney's fees asserted against MarkeTrends Productions, its agents, its
# customers, officers and employees, that may arise or result from any
# service provided or performed or agreed to be performed or any product
# sold by customer, its agents, employees or assigns. Customer agrees to
# defend, indemnify and hold harmless MarkeTrends Productions, its agents,
# its cusomters, officers, and employes,against
# liabilities arising out of; a) any injury to person or property caused
# by an products sold or  otherwise distributed in connection with 
# MarkeTrends Productions products; (b) any material supplied by customer
# infringing or allegedly infringing on the proprietary rights of a
# third party; c) copyright infringement and (d) any defective products
# sold to customer from MarkeTrends Productions products.
#
##############################################################################
#
# Now onto the good stuff...  :-)
#
##############################################################################
# Create a folder called 'mailer' and then inside the mailer folder, create
# another folder called 'lists' and one called 'messages'.
# General file layout and there permissions shown below.
##############################################################################
# |/mailer/                    777 (rwxrwxrwx) Some servers require 755 (rwxr-xr-x)
#     | simplemail.pl          755 (rwxr-xr-x) for the mailer folder before the script
#     | mailer.pl              755 (rwxr-xr-x) will work.
#     | unsub.pl               755 (rwxr-xr-x)
#     | signup.pl              755 (rwxr-xr-x)
#     | config.pl              755 (rwxr-xr-x)
#     | emailpost.pl           755 (rwxr-xr-x)
#     | export.pl              755 (rwxr-xr-x)
#     | bounce.pl              755 (rwxr-xr-x)
#     | que.db                 666 (rw-rw-rw-)  theses files will automatically be
#     | list_id.db             666 (rw-rw-rw-)  created the first time you login to
#     | reject.db              666 (rw-rw-rw-)  the control panel
#     | rstore_id.db           666 (rw-rw-rw-)
#     | bounce.db              666 (rw-rw-rw-)
#     | logs.db                666 (rw-rw-rw-)
#     | doptin.db              666 (rw-rw-rw-)
#     | optout.db              666 (rw-rw-rw-)
#     | mail.db                666 (rw-rw-rw-)
#     | index.html             644 (rw-r--r--)
#     | help.htm               644 (rw-r--r--)
#     |/messages/              777 (rwxrwxrwx)
#         | sub_message_1      666 (rw-rw-rw-)  theses files will automatically be
#         | unsub_message_1    666 (rw-rw-rw-)  created the first time you login to
#         | footer_messages_1  666 (rw-rw-rw-)  the control panel.
#         | etc...
#  
#     |/lists/                 777 (rwxrwxrwx)
#         | list_file_1        666 (rw-rw-rw-) theses files will automatically be
#         | list_file_2        666 (rw-rw-rw-) created the first time you login to
#         | etc...                             the control panel.
##############################################################################
# Set the folder permissions that simplemail script resides to 777 (rwxrwxrwx)
# Set the folder permissions for the lists folder to 777 (rwxrwxrwx)
# Set the folder permissions for the messages folder to 777 (rwxrwxrwx)
# Set the files: simplemail.pl, unsub.pl, mailer.pl, signup.pl, config.pl,
# emailpost.pl, bounce.pl and export.pl permissions to 755 (rwxr-xr-x)
#
# Make sure to set the full path for the "require" on all 7 scripts.
#
#  require "/full/path/to/mailer/config.pl";
#
#
# NOTE: Before this program will do any emailing,  you will need to insert
# this line into your servers crontab file.
# */5  *  *  *  *  youruserid  /some/path/to/mailer/mailer.pl
# 
##############################################################################
# Build number.
$ver = "(SimpleMail 4.9.9a, Jun 2004)";
# Path to your base directory. do not include the / at the end.
$basedir = "/full/path/to/mailer";
# Base URL path to your SimpleMail program. do not include the / at the end.
$baseurl = "http://www.somedomain.com/mailer";
# Back to your web site EXIT return address.
$exiturl = "http://www.somedomain.com/";
##############################################################################
# To use your SMTP server instead of sendmail.  Enter your SMTP server
# host name below. Example: $smtpserver = "mail.somedomain.com"; else leave 
# this setting empty.
$smtpserver = "";
##############################################################################
# Bounce return email address.  If the system user is a different user than
# SimpleMail mailer runs under or you would just like to have the bounces come 
# back to a different configured email address for SimpleMail,  then place
# that email address below.  $bouncereturn = 'myreturn@somedomain.com';
# otherwise leave this variable empty. Or if you are using SMTP setting above
# to deliver the email,  you will need to supply a valid bounce return address.
$bouncereturn = '';
##############################################################################
# Path to your sendmail.
$mailprog = '/usr/sbin/sendmail';
##############################################################################
# Set your time zone.
# You can set the time offset for SimpleMail to work in your time zone 
# should your server be located elsewhere.  Here are some simple suggestions
# If your server is in the same time zone,  then the current setting is correct.
# If your server is in another timezone,  you can offset the time by setting
# the number of hours difference.  Let's say your in california and your server
# is in newyork,  by changing this variable ($offset) to +4 will move your time 
# ahead 4 hours.  The oppisite will occur if you use -4 will move you back 4 hours.
$offset = "-0";
##############################################################################
# NOTE: The date command configured in SimpleMail takes advantage of
# a feature that allows the time to be set to different time zones. This 
# feature is not supported by all OS's and if you find this to be the case in
# your situation you can make the following change to the date command from
#   $date_command = "/bin/date -v" . " $offset" . "H";
# to 
#   $date_command = "/bin/date";
##############################################################################
# Path to your date program.
$date_command = "/bin/date -v" . " $offset" . "H";
##############################################################################
# Path to your copy command.
$cp = "/bin/cp";
##############################################################################
# Administrators login password.
$password = "password";
##############################################################################
# SimpleMail is set for double optin by default.  If you would like to 
# disable this feature, set $doptin to '0' else leave it set to '1'.
$doptin = "1";
##############################################################################
# If you would like to be notified when someone subscribes or unsubscribes
# then set the value of $notify = 1 otherwise set $notify = 0
$notify = "1";
##############################################################################
# To require a subscriber to enter their name during signup,  set the 
# $sub_name to '1' else set the value to '0'.
$sub_name = "1";
##############################################################################
# To clear subject and message fields after each submission set $clear = 1
# else set $clear = 0 to retain content.
$clear = "0";
##############################################################################
# Delay in seconds before advancing back to the home page after the signup.
# Set $delay to 0 if you want to eliminate the status page before advancing
# to the home page or thank you page.
$delay = "4";
##############################################################################
# Number of unique archive's to be made available for the Restore feature.
$restcount = "5";
##############################################################################
# Mailserver batch control settings.
# Some mailservers will only allow a set number of emails to be sent during
# a given period of time.  SimpleMail provides a way to control this during
# mail delivery.  These settings by default are disabled,  however they are
# as follows.
# Batch size. This setting will determin how many emails to send in the batch.
# If it is necessary to limit your email deliveries,  try setting this value
# to Example: $batchsize = "200"; this is a good starting point.
$batchsize = "0";
# Pause time. This setting determins how much time to pause between batches.
# should you need to control your batch size,  try running your setting to a
# value to 30 seconds. Example: $pausetime = "30";
$pausetime = "0";
##############################################################################
# MetaCharacter to real character conversion table.
# Sometimes when you copy and paste a message from email or a word processing
# program,  metacharacters are copied over instead of the real characters. So
# this list shown below is some of the common metacharacters we want to convert 
# back to real characters.  Feel free to add to this list any character you wish
# to convert.
# Format: 'metacharacter|realcharacter', 'metacharacter|realcharacter' etc...
@metaconv = ('&#8217;|\'', '&amp;|&', '&quot;|"', '&#8211;|-', '&#8230;|...');
##############################################################################
#
# Your done with the setup of your configuration file unless you wish
# to customize the location of where files are kept.
#
##############################################################################
# Path to where the lockfiles will be located.
# No need to create these six files as they are dynamicly generated and 
# deleted automatically as SimpleMail runs.
$que_lock = "$basedir/.que";
$lockfile = "$basedir/.mail";
$mailrun = "$basedir/.mrun";
$maildump = "$basedir/.mdump";
$loglock = "$basedir/.log";
$optinlock = "$basedir/.optin";
# No need to modify these next 16 variables for a default setup.
# Path to your email lists folder.
$database = "$basedir/lists";
# Path to your messages folder.
$sys_messages = "$basedir/messages";
# Path to the mail queue file.
$mail_que = "$basedir/que.db";
# Path to the mail archive file.
$mail_archive = "$basedir/mail.db";
# Path to bounce database file.
$bouncelist = "$basedir/bounce.db";
# Path to the List ID file.
$listid = "$basedir/list_id.db";
# Path to Restore ID file.
$rstoreid = "$basedir/rstore_id.db";
# Path to the logfile.
$logs = "$basedir/logs.db";
# Path to optin database file.
$dboptin = "$basedir/doptin.db";
# Path to optout database file.
$optout = "$basedir/optout.db";
# Path to the email subscribers reject file.
$reject = "$basedir/reject.db";
# URL Path to the simplemail.pl script.
$cgiurl = "$baseurl/simplemail.pl";
# URL Path to the unsub.pl script. 
$ftrlink = "$baseurl/unsub.pl";
# URL Path to the signup.pl script
$optin_confirm_link = "$baseurl/signup.pl";
# Export URL path.
$exporturl = "$baseurl/export.pl";
# Path to help file.
$helpfile = "$basedir/help.htm";
##############################################################################
#
# END.