#!/usr/bin/perl
$|=1;
##############################################################################
# SimpleMail Mailer Engine.     See $ver for build.                          #
# Copyright 2002 MarkeTrends    mrt@marketrends.net                          #
# Created 09/18/00              Last Modified 07/05/04                       #
##############################################################################
# Set the full server path to your config.pl file.
require "/full/path/to/mailer/config.pl";
##############################################################################
# No need to edit beyond this point.  Please refer to the config.pl
# for settings in this script.
##############################################################################
use Benchmark;
use Net::SMTP;
$time = time();
$date  = `$date_command +"%m\/%d\/%Y"`; chop($date);
$hour = `$date_command +"%H"`; chop($hour); $day = `$date_command +"%d"`; chop($day);
$month = `$date_command +"%b"`; chop($month); $year = `$date_command +"%Y"`; chop($year);

&lock_clear;
if (-z $mail_que) {exit;}

	if (-e $maildump) { 
	$mdump = "1";
	}
	else {
	$mdump = "0";
	}

while (-e $mailrun) {exit;}
open(LOCK,">$mailrun") || die "Cannot create mail run file because: $!\n";
print LOCK "$time"; close(LOCK);
chmod 0666, "$mailrun";

open(MQ, "$mail_que")|| die "Cannot read the mail queue file because: $!\n";
@que_array = <MQ>; close (MQ);

@job = ();
foreach $que_up (@que_array){ chomp($que_up);
@que_data = split (/\|/, $que_up);

if ($que_data[8] ne "Sending Now") {
	@quesrc = split('\:', "$que_data[8]");
	$ok = "0";
	if ($hour >= $quesrc[0]) {
		if ($month eq "$quesrc[1]") {
			if ($day eq "$quesrc[2]") {
				if ($year eq "$quesrc[3]") {
				$ok = "1";
				}
			}
		}
	}
	if ($ok ne "1") {
	next;
	}
}

$message = "$que_data[4]";
$message =~ s/ xxnlxx /\n/g;
$message .= "\n";
$news_list = "$que_data[7]";
$news_list =~ s/\_import$//g;

open(DATA, "$database/$que_data[7]")|| die "Cannot read from the maillist because: $!\n";
@records = <DATA>; close (DATA);

$footrm = "$sys_messages" . "/" . "$news_list" . "_foot";
if (-s "$footrm") {
open(FTR, "$footrm");
@foot = <FTR>; close (FTR);
}

if ($mdump ne "1") {
	$suc = "0"; $elapsed = "0"; $mdump = "0";
	$delay = "0"; $batch = "0";
	$start = new Benchmark;
	foreach $too (@records){ chomp($too);
		if ($too =~ /^#/) { next; }
		$delay++; $batch++;
		unless (($batchsize eq "0") && ($pausetime eq "0")) {
			if ($batch > "$batchsize") {
			sleep($pausetime);
			$batch = "0";
			}
		}
		if ($delay > "50") {
			if (-e $maildump) {
			$mdump = "1";
			last;
			}
			else {
			$delay = "0";
			}
		}
		$hmny = ($too =~ tr/\,/\,/); $ename = "";
		if ($hmny eq "1") {
		($ename, $to) = split(',', $too, 2);
		}
		elsif ($hmany > "1") {
		next;
		}
		else {
		$to = "$too";
		}
		if ($ename !~ /\w+/) {
		$ename = "Friend";
		}
		$messagex = ""; $messagex = "$message";
		$messagex  =~ s/<-name->/$ename/ig;
		$messagex  =~ s/<-email->/$to/ig;
		$messagex  =~ s/<-news_list->/$news_list/ig;
		$subject = ""; $subject = "$que_data[3]";
		$subject  =~ s/<-name->/$ename/ig;
		$subject  =~ s/<-email->/$to/ig;
		$subject  =~ s/<-news_list->/$news_list/ig;
		if (-s "$footrm") {
		&footer;
		}
		$to =~ s/\s+//g;
		$tolog = "$to"; $tolog =~ s/\@|\./\^/g;
		if ($to =~ /\w/){$suc++;
			if ($smtpserver =~ /\w/) {
			$smtp = Net::SMTP->new($smtpserver);
				$smtp->mail($bouncereturn);
				$smtp->to($to, { Notify => ['NEVER'], SkipBad => 1 });
				$smtp->data();
				if ($que_data[6] eq "ON") {
					$smtp->datasend("Disposition-Notification-To: \"$que_data[1]\" <$que_data[2]>\n");
				}
				$smtp->datasend("Reply-To: $que_data[1] <$que_data[2]>\n");
				$smtp->datasend("From: $que_data[1] <$que_data[2]>\n");
				$smtp->datasend("To: $to\n");
				$smtp->datasend("Subject: $subject\n");
				if ($que_data[5] eq "ON"){
					$smtp->datasend("X-Mailer: SimpleMail\n");
					$smtp->datasend("X-SimpleMail-ver: $ver\n");
					$smtp->datasend("X-SimpleMail-ea: $tolog\n");
					$smtp->datasend("X-SimpleMail-nl: $news_list\n");
					$smtp->datasend("Content-Type: text/html\n");
				}
				else {
					$smtp->datasend("X-Mailer: SimpleMail\n");
					$smtp->datasend("X-SimpleMail-ver: $ver\n");
					$smtp->datasend("X-SimpleMail-ea: $tolog\n");
					$smtp->datasend("X-SimpleMail-nl: $news_list\n");
				}
				$smtp->datasend("\n");
				$smtp->datasend("$messagex\n\n");
				$smtp->dataend();
			$smtp->quit;
			}
			else {
				if ($bouncereturn =~ /\w+/) {
				open (MAILA, "|$mailprog -oi -t -f $bouncereturn");
				}
				else {
				open (MAILA, "|$mailprog -oi -t");
				}
				if ($que_data[6] eq "ON") {
					print MAILA "Disposition-Notification-To: \"$que_data[1]\" <$que_data[2]>\n";
				}
					print MAILA "Reply-To: $que_data[1] <$que_data[2]>\n";
					print MAILA "From: $que_data[1] <$que_data[2]>\n";
					print MAILA "To: $to\n";
					print MAILA "Subject: $subject\n";
				if ($que_data[5] eq "ON"){
					print MAILA "X-Mailer: SimpleMail\n";
					print MAILA "X-SimpleMail-ver: $ver\n";
					print MAILA "X-SimpleMail-ea: $tolog\n";
					print MAILA "X-SimpleMail-nl: $news_list\n";
					print MAILA "Content-Type: text/html\n\n";
				}
				else{
					print MAILA "X-Mailer: SimpleMail\n";
					print MAILA "X-SimpleMail-ver: $ver\n";
					print MAILA "X-SimpleMail-ea: $tolog\n";
					print MAILA "X-SimpleMail-nl: $news_list\n\n";
				}
					print MAILA "$messagex\n\n";
				close (MAILA);
			}
		}
	}
	&mail_results;
}
	push (@job, $que_data[0]);
	if ($mdump eq "1") {
	last;
	}
}# end of $que_up.

while (-e $que_lock) {}
open(LOCK,">$que_lock") || die "Cannot create the mail queue lockfile because: $!\n";
print LOCK "$time"; close(LOCK);
chmod 0666, "$que_lock";

open(MQ, "$mail_que")|| die "Cannot read from the mail queue file because: $!\n";
@que_array = <MQ>; close (MQ);

open(MQ, ">$mail_que")|| die "Cannot write to the mail queue file because: $!\n";
foreach $que_clean (@que_array) {chomp($que_clean);
$entry = "0";
@clean_data = split (/\|/, $que_clean);
	foreach $clean (@job) {chomp($clean);
		if ($clean eq "$clean_data[0]") {
		$entry = "1";
		last;
		}
	}
	if ($entry eq "0"){
	print MQ "$que_clean\n";
	}
}
close (MQ);
unlink ($que_lock);
unlink ($mailrun);
unlink ($maildump);
exit;

sub log_event {
while (-e $loglock) {}
open(LOGLOCK,">$loglock") || die "Cannot create the lockfile for logging because: $!\n";
print LOGLOCK "$time"; close(LOGLOCK);
chmod 0666, "$loglock";

open(LOG, ">>$logs")|| die "Cannot write to the logfile file because: $!\n";
print LOG "$_[0]\n";
close (LOG);

unlink ($loglock);
}

sub mail_error {

open(MQ, "$mail_que")|| die "Cannot read the mail queue file because: $!\n";
@que_array = <MQ>; close (MQ);
	foreach $que_up (@que_array){ chomp($que_up);
	@que_data = split (/\|/, $que_up);
		if ($smtpserver =~ /\w/) {
		$smtp = Net::SMTP->new($smtpserver);
			$smtp->mail($bouncereturn);
			$smtp->to($que_data[2]);
			$smtp->data();
			$smtp->datasend("Reply-To: $que_data[1] <$que_data[2]>\n");
			$smtp->datasend("From: $que_data[1] <$que_data[2]>\n");
			$smtp->datasend("To: $que_data[1] <$que_data[2]>\n");
			$smtp->datasend("Subject: SimpleMail Send Error.\n");
			$smtp->datasend("X-Mailer: SimpleMail\n");
			$smtp->datasend("X-SimpleMail-ver: $ver\n");
			$smtp->datasend("\n");
			$smtp->datasend("SimpleMail has encountered an error and has purged\n");
			$smtp->datasend("this message from the Mail Que to prevent a duplication\n");
			$smtp->datasend("mailing to this list.\n\n");
			$smtp->datasend("Things to look for are:\n");
			$smtp->datasend("  * Server being rebooted while the list was being mailed.\n");
			$smtp->datasend("  * Non standard characters being used in an email address.\n");
			$smtp->datasend("  * Incorrectly configured List Profile.\n");
			$smtp->datasend("  * SimpleMail not setup correctly.\n\n");
			$smtp->datasend("Date Sent: $date\n\n");
			$smtp->dataend();
		$smtp->quit;
		}
		else {
		open (MAIL, "|$mailprog -oi -t");
			print MAIL "Reply-To: $que_data[1] <$que_data[2]>\n";
			print MAIL "From: $que_data[1] <$que_data[2]>\n";
			print MAIL "To: $que_data[1] <$que_data[2]>\n";
			print MAIL "Subject: SimpleMail Send Error.\n\n";
			print MAIL "List Used: $que_data[7]\n";
			print MAIL "Subject: $que_data[3]\n\n";
			print MAIL "SimpleMail has encountered an error and has purged\n";
			print MAIL "this message from the Mail Que to prevent a duplication\n";
			print MAIL "mailing to this list.\n\n";
			print MAIL "Things to look for are:\n";
			print MAIL "  * Server being rebooted while the list was being mailed.\n";
			print MAIL "  * Non standard characters being used in an email address.\n";
			print MAIL "  * Incorrectly configured List Profile.\n";
			print MAIL "  * SimpleMail not setup correctly.\n\n";
			print MAIL "Date Sent: $date\n\n";
		close (MAIL);
		}
	&log_event("ERROR: SimpleMail Error: Server rebooted or 24 hour window exceeded., List Used: $que_data[7], Subject: $que_data[3], Date Sent: $date");
	}
}

sub mail_results {
$finish = new Benchmark;
$td = timediff($finish, $start);
$elapsed = sprintf("%.2f", (timestr($td, 'time') / 60));
	if ($smtpserver =~ /\w/) {
	$smtp = Net::SMTP->new($smtpserver);
		$smtp->mail($bouncereturn);
		$smtp->to($que_data[2]);
		$smtp->data();
		$smtp->datasend("Reply-To: $que_data[1] <$que_data[2]>\n");
		$smtp->datasend("From: $que_data[1] <$que_data[2]>\n");
		$smtp->datasend("To: $que_data[1] <$que_data[2]>\n");
		$smtp->datasend("Subject: SimpleMail Send Results.\n");
		$smtp->datasend("X-Mailer: SimpleMail\n");
		$smtp->datasend("X-SimpleMail-ver: $ver\n");
		$smtp->datasend("\n");
		$smtp->datasend("List Used: $que_data[7]\n");
		$smtp->datasend("Subject: $que_data[3]\n");
		$smtp->datasend("Total Messages Processed: $suc\n");
		$smtp->datasend("Time Elapsed(min): $elapsed\n");
		$smtp->datasend("Date Sent: $date\n\n");
		$smtp->dataend();
	$smtp->quit;
	}
	else {
	open (MAIL, "|$mailprog -oi -t");
		   print MAIL "Reply-To: $que_data[1] <$que_data[2]>\n";
		   print MAIL "From: $que_data[1] <$que_data[2]>\n";
		   print MAIL "To: $que_data[1] <$que_data[2]>\n";
		   print MAIL "Subject: SimpleMail Send Results.\n\n";
		   print MAIL "List Used: $que_data[7]\n";
		   print MAIL "Subject: $que_data[3]\n";
		   print MAIL "Total Messages Processed: $suc\n";
		   print MAIL "Time Elapsed(min): $elapsed\n";
		   print MAIL "Date Sent: $date\n\n";
	close (MAIL);
	}
&log_event("SUCCESS: SimpleMail Mail Results: List Used: $que_data[7], Subject: $que_data[3], Total Messages Processed: $suc, Time Elapsed(min): $elapsed, Date Sent: $date");	
}

sub lock_clear {

	if (-e $lockfile) {
        open(FILE,"$lockfile");
        $timestamp=<FILE>;
        close(FILE);
        $timestamp =~s/\n//g;

        $test = $time - $timestamp;

        if ($test > 60){
             unlink ($lockfile);
        }

	}
	
	if (-e $loglock) {
        open(FILE,"$loglock");
        $timestamp=<FILE>;
        close(FILE);
        $timestamp =~s/\n//g;

        $test = $time - $timestamp;

        if ($test > 60){
             unlink ($loglock);
        }

	}
	
	if (-e $optinlock) {
        open(FILE,"$optinlock");
        $timestamp=<FILE>;
        close(FILE);
        $timestamp =~s/\n//g;

        $test = $time - $timestamp;

        if ($test > 60){
             unlink ($optinlock);
        }

	}
	
	if (-e $que_lock) {
        open(FILE,"$que_lock");
        $timestamp=<FILE>;
        close(FILE);
        $timestamp =~s/\n//g;

        $test = $time - $timestamp;

        if ($test > 60){
             unlink ($que_lock);
        }

	}
	# Clear lock file after 24 hours (86400)
	if (-e $mailrun) {
        open(FILE,"$mailrun");
        $timestamp=<FILE>;
        close(FILE);
        $timestamp =~s/\n//g;

        $test = $time - $timestamp;

        if ($test > 86400){
		&mail_error;
		open(MQ, ">$mail_que"); close(MQ);
		unlink ($mailrun);
        }

	}

}

sub footer {
$out = &cp2("$to");
$msguid = "$ftrlink" . "?user=" . "$out" . "&" . "list=" . "$news_list";
$msguid =~ s/\s+//g;
$messagepr = join('', @foot);
	if ($que_data[5] eq "ON"){
	$messagepr =~ s/\n/\n<br>/g;
	$messagepr .= qq(<a href="$msguid">Unsubscribe Me.</a>\n);
	}
	else {
	$messagepr .= "$msguid\n";
	}
$messagex .= "$messagepr";
}

sub cp2 { $_ = "$_[0]";
 tr/a-z0-9/td5kvsa9c47mnezhwi38jbgo0q1xlruy26pf/;
 s/\-/\!/g;
 s/\./\~/g;
 s/\@/\^/g;
 return $_;
} 
 