#!/usr/bin/perl
$|=1;
##############################################################################
# SimpleMail Email Bounce Script See $ver for build.                         #
# Copyright 2002 MarkeTrends     mrt@marketrends.net                         #
# Created 02/26/01               Last Modified 06/14/03                      #
##############################################################################
# Set the full server path to your config.pl file.
require "/full/path/to/mailer/config.pl";
##############################################################################
# No need to edit beyond this point.  Please refer to the config.pl
# for settings in this script.
##############################################################################
@orgmail=<STDIN>;
##############################################################################
$found = "0"; $simplefound = "0";
&get_info;
if (($found eq "1") && ($simplefound eq "1")) {
	open(BOUNCE, ">>$bouncelist") || die "Cannot write to the Bounce List because: $!\n";
	print BOUNCE "$xemail|$xreason\n";
	close(BOUNCE);
}
exit;

sub get_info {
	foreach $each (@orgmail) {
		if ($each =~ /X-SimpleMail-ver:/i) {
		$simplefound = "1";
		last;
		}
	}
	
	# looking for sendmail bounces.
	$sendmailfnd = "0";
	foreach $each (@orgmail) { $each =~ s/^\s|^\t//g;
		if ($each =~ /The following addresses had permanent fatal errors/i) {
		$found = "1";
		next;
		}
		if (($each =~ /\@/) && ($found eq "1") && ($sendmailfnd eq "0") && ($each !~ /\>\.\.\.|RCPT To:|reason:/)) {
		$xemail = $each; chomp($xemail);
		$xemail =~ s/\<|\>|\s|To:|\"|\(|\)|expanded from\:|Final\-Recipient\: RFC822\;//gi;
		$sendmailfnd = "1";
		next;
		}
		if (($each =~ /reason:|\>\.\.\.|could not be delivered/i) && ($sendmailfnd eq "1") && ($found eq "1")) {
		$xreason = $each; chomp($xreason);
		$xreason =~ s/reason: |\(|\)//g; $xreason =~ s/^\s+//g;
		last;
		}
	}
	
	# Looking for postfix bounces.
	if ($found eq "0") {
		foreach $each (@orgmail) { $each =~ s/^\s|^\t//g;
			if ($each =~ /This is the Postfix program/i) {
			$found = "1";
			next;
			}
			if (($each =~ /\@/) && ($found eq "1") && ($each =~ /\:/)) {
			$xpemail = $each; chomp($xpemail);
			$xpemail =~ s/\<|\>//gi;
			($xemail, $xreason) = split('\:', "$xpemail");
			$xemail =~ s/\s|\"//gi;
			$xreason =~ s/^\s+//g;
			last;
			}
		}
	}
	
	# looking for qmail bounces.
	if ($found eq "0") {
		$qmailfnd = "0";
		foreach $each (@orgmail) { $each =~ s/^\s|^\t//g;
			if ($each =~ /This is the qmail-send program/i) {
			$found = "1";
			next;
			}
			if (($each =~ /\@/) && ($qmailfnd eq "0") && ($found eq "1") && ($each =~ /\:$/)) {
			$xemail = $each; chomp($xemail);
			$xemail =~ s/\<|\>|\s|\:|\"//gi;
			$qmailfnd = "1";
			next;
			}
			if (($qmailfnd eq "1") && ($found eq "1")) {
			$xreason = $each; chomp($xreason);
			$xreason =~ s/^\s+//g;
			last;
			}
		}
	}
}
