#!/usr/bin/perl
$|=1;
##############################################################################
# SimpleMail Email Post Script  See $ver for build.                          #
# Copyright 2002 MarkeTrends    mrt@marketrends.net                          #
# Created 02/26/01              Last Modified 06/21/04                       #
##############################################################################
# Set the full server path to your config.pl file.
require "/full/path/to/mailer/config.pl";
##############################################################################
# No need to edit beyond this point.  Please refer to the config.pl
# for settings in this script.
##############################################################################
@orgmail=<STDIN>;
use Net::SMTP;
$time = time();
$date  = `$date_command +"%m\/%d\/%Y"`; chop($date);
##############################################################################

&get_info;
	if ($xmailer =~ /xloop/) { exit; }
&chkemail;

if ($condition eq "subscribe") {
	if ($doptin eq "1") {
	&dboptin;
	}
	else {
	&subscr;
	&email;
	}
}

if ($condition eq "unsubscribe") {
	&unsub;
	&email;
}

##########################################################
# Sub Routines.

sub email {
		
		$subs = "$sys_messages" . "/" . "$news_list" . "_sub";
		$unsubs = "$sys_messages" . "/" . "$news_list" . "_unsub";
		
		if ($condition eq "subscribe"){$mail_file = "$subs"; $cond = "Subscribed to";}
		if ($condition eq "unsubscribe"){$mail_file = "$unsubs"; $cond = "Unsubscribed from";}

		$msguid = "mailto:$emailto?Subject=unsubscribe+$newslist";
		
		open(TEMPL, "$mail_file") || die "cannot open $mail_file because $!";
		@text = <TEMPL>; close (TEMPL);
		if ($smtpserver =~ /\w/) {
		$smtp = Net::SMTP->new($smtpserver);
			$smtp->mail($bouncereturn);
			$smtp->to($email);
			$smtp->data();
			$smtp->datasend("Reply-To: $ol[1] <$ol[2]>\n");
			$smtp->datasend("From: $ol[1] <$ol[2]>\n");
			$smtp->datasend("To: $email\n");
			$smtp->datasend("X-SimpleMail: xloop\n");
		foreach $text_line (@text) {
			$text_line =~ s/%%name%%/$name/g;
			$text_line =~ s/%%email%%/$email/g;
			$text_line =~ s/%%unsub%%/$msguid/g;
			$text_line =~ s/%%newsletter%%/$news_list/g;
			$text_line =~ s/%%date%%/$date/g;
			$smtp->datasend("$text_line");
		}
			$smtp->dataend();
		$smtp->quit;
		}
		else {
		open (MAIL, "|$mailprog -oi -t");
		
		   print MAIL "Reply-to: $ol[1] <$ol[2]>\n";
		   print MAIL "From: $ol[1] <$ol[2]>\n";
		   print MAIL "To: $email\n";
		   print MAIL "X-SimpleMail: xloop\n";
		foreach $text_line (@text) {
				$text_line =~ s/%%name%%/$name/g;
				$text_line =~ s/%%email%%/$email/g;
				$text_line =~ s/%%unsub%%/$msguid/g;
				$text_line =~ s/%%newsletter%%/$news_list/g;
				$text_line =~ s/%%date%%/$date/g;
		   print MAIL "$text_line";
		}
		close (MAIL);
		}
		
		&log_event("SUCCESS: Email Post: $cond, NewsList: $news_list, Name: $name, Email Address: $email, IP Address: $recnum, Date: $date");
		
		if ($notify eq "1") {
			if ($smtpserver =~ /\w/) {
			$smtp = Net::SMTP->new($smtpserver);
				$smtp->mail($bouncereturn);
				$smtp->to($ol[2]);
				$smtp->data();
				$smtp->datasend("Reply-To: $email\n");
				$smtp->datasend("From: $email\n");
				$smtp->datasend("To: $ol[1] <$ol[2]>\n");
				$smtp->datasend("Subject: $email has $cond your $news_list list via an email post.\n");
				$smtp->datasend("\n");
				$smtp->datasend("Hello $ol[1],\n\n");
				$smtp->datasend("$name $email has $cond your $news_list list.\n");
				$smtp->datasend("Date $cond: $date\n\n");
				$smtp->datasend("Thanks from SimpleMail\n\n\n");
				$smtp->datasend("--------------- Header Info ---------------\n\n");
				$smtp->datasend(@header);
				$smtp->datasend("\n--------------- END ---------------\n");
				$smtp->dataend();
			$smtp->quit;
			}
			else {
			open (MAIL, "|$mailprog -oi -t");
			
			   print MAIL "Reply-to: $email\n";
			   print MAIL "From: $email\n";
			   print MAIL "To: $ol[1] <$ol[2]>\n";
			   print MAIL "X-SimpleMail: xloop\n";
			   print MAIL "Subject: $email has $cond your $news_list list via an email post.\n\n";
			   print MAIL "Hello $ol[1],\n\n";
			   print MAIL "$name $email has $cond your $news_list list.\n";
			   print MAIL "Date $cond: $date\n\n";
			   print MAIL "Thanks from SimpleMail\n\n\n";
			   print MAIL "--------------- Header Info ---------------\n\n";
			   print MAIL @header;
			   print MAIL "\n--------------- END ---------------\n";
			   
			close (MAIL);
			}
		}

exit;
}

sub dboptin {
open(OPTIN, "$dboptin") || die "cannot open $dboptin because $!";
@optin_list = <OPTIN>; close (OPTIN);

$testa = "0";
foreach $chk_optin (@optin_list) {
@chkopt = split('\|', "$chk_optin");
	if (($chkopt[2] eq "$email") && ($news_list eq "$chkopt[3]")) {
		$testa = "1";
		last;
	}
}
if ($testa eq "1") {
$bad_addr .= qq(It appears that your email address '$email' was\nalready submitted for subscription but not yet confirmed.\n\nPlease check your email and click on the link provided\nto confirm your subscription to the '$news_list' newsletter.);
&mail_notice;
}

while (-e $optinlock) {}
open(LOCK,">$optinlock") || die "Cannot create $!\n";
print LOCK "$time"; close(LOCK);
chmod 0666, "$optinlock";

	open(TEMP, ">>$dboptin") || die "cannot open $dboptin because $!";
	print TEMP "$time|$name|$email|$news_list|$exiturl|$condition|$recnum|$date\n";
	close (TEMP);
	
	$confirm_optin = "$optin_confirm_link" . "?confirm=" . "$time";
	$optin = "$sys_messages" . "/" . "$news_list" . "_optin";
	
	open(TEMPL, "$optin") || die "cannot open $optin because $!";
	@text = <TEMPL>; close (TEMPL);
	
	if ($smtpserver =~ /\w/) {
	$smtp = Net::SMTP->new($smtpserver);
		$smtp->mail($bouncereturn);
		$smtp->to($email);
		$smtp->data();
		$smtp->datasend("Reply-To: $ol[1] <$ol[2]>\n");
		$smtp->datasend("From: $ol[1] <$ol[2]>\n");
		$smtp->datasend("To: $email\n");
		$smtp->datasend("X-SimpleMail: xloop\n");
	foreach $text_line (@text) {
		$text_line =~ s/%%name%%/$name/g;
		$text_line =~ s/%%email%%/$email/g;
		$text_line =~ s/%%confirm%%/$confirm_optin/g;
		$text_line =~ s/%%newsletter%%/$news_list/g;
		$text_line =~ s/%%date%%/$date/g;
		$smtp->datasend("$text_line");
	}
		$smtp->dataend();
	$smtp->quit;
	}
	else {
	open (MAIL, "|$mailprog -oi -t");
		print MAIL "Reply-to: $ol[1] <$ol[2]>\n";
		print MAIL "From: $ol[1] <$ol[2]>\n";
		print MAIL "To: $email\n";
		print MAIL "X-SimpleMail: xloop\n";
	foreach $text_line (@text) {
			$text_line =~ s/%%name%%/$name/g;
			$text_line =~ s/%%email%%/$email/g;
			$text_line =~ s/%%newsletter%%/$news_list/g;
			$text_line =~ s/%%confirm%%/$confirm_optin/g;
			$text_line =~ s/%%date%%/$date/g;
		print MAIL "$text_line";
	}
	close (MAIL);
	}
	
unlink($optinlock);
&log_event("SUCCESS: Email Post: Double Optin First Step, NewsList: $news_list, Name: $name, Email Address: $email, IP Address: $recnum, Date: $date");
exit;
}

sub chkemail {
$mailerdaemon = "0";
open(LST, "$listid") || die "Cannot read $listid because: $!\n";
@li_names = <LST>; close(LST);

open(REJ, "$reject") || die "Cannot open $reject because: $!\n";
@rjects = <REJ>; close(REJ);

	unless (($condition eq "unsubscribe") || ($condition eq "subscribe")) {
		$bad_addr = qq(SimpleMail could not determin whether you wanted to subscribe or unsubscribe,\nEnter either action into the subject line followed by the list name\nExample: subscribe xyzlist \nExample: unsubscribe xyzlist\n\nNo action taken.);
		$mailerdaemon = "1";
		&mail_notice;
	}

	if ($newslist !~ /\w/) {
		$bad_addr = qq(There was no list identified in your subject,\nExample: subscribe xyzlist \nExample: unsubscribe xyzlist\n\nNo action taken.\n);
		$mailerdaemon = "1";
		&mail_notice;
	}

		$listok = "0";
		foreach $list_chk (@li_names) { chomp($list_chk);
			@ol = split('\|', $list_chk, 3);
			$news_list = "$ol[0]"; $newschk = lc($ol[0]);
			if ($newslist eq "$newschk") {
			$listok = "1";
			last;
			}
		}
		
		if ($listok eq "0") {
			$bad_addr = qq(There is no such list called '$newslist'.\n\nNo action taken.\n);
			$mailerdaemon = "1";
			&mail_notice;
		}
		
		open(DATA, "$database/$news_list")|| die "Cannot open $database/$news_list because: $!";
		@array = <DATA>; close (DATA);
		
			$chkinfo = "0"; $cnt = "0";
			foreach $listz (@array) {chomp($listz); $hmny = ($listz =~ tr/\,/\,/);
				if ($hmny eq "1") {
				($null, $list) = split(',', $listz, 2);
				}
				else {
				$list = "$listz";
				}
				$lista = lc($list);
				$lista =~ s/\s//g;
				if ($condition eq "subscribe") {
					if ($eaddr eq "$lista") {
					$bad_addr .= qq(Your email address '$email' is already subscribed to the '$news_list' list.\n\nNo action taken.\n);
					&mail_notice;
					}
				}
				if ($condition eq "unsubscribe") {
						if ($eaddr eq "$lista") {
						$cnt = "1";
						last;
						}
				}
			}
			if (($cnt ne "1") && ($condition eq "unsubscribe")){
			$bad_addr .= qq(Your email address '$email' was not found in the '$news_list' list and therefore could not be unsubscribed.\n\nNo action taken.\n);
			&mail_notice;
			}
			
			if ($condition eq "subscribe") {
				foreach $rej (@rjects) {$rej =~ s/\s//g;
					if ($eaddr =~ /$rej/i) {
					$bad_addr .= qq(Email Address or domain name is on our reject list.\n\nNo action taken.\n);
					$chkinfo = "1";
					}
				}
			}
	if ($chkinfo eq "1") {&mail_notice;}

}
	
sub subscr {
open(OPTOUT, "$optout") || die "Cannot read $optout, because: $!\n";
@optout_array = <OPTOUT>; close(OPTOUT);

while (-e $lockfile) {}
open(LOCK,">$lockfile") || die "Cannot create $!\n";
print LOCK "$time"; close(LOCK);
chmod 0666, "$lockfile";
	
	open(DATA, ">>$database/$news_list")|| die "Cannot open $database/$news_list because: $!";
		if ($name =~ /\w+/) {
		print DATA "$name, $eaddr\n";
		}
		else {
		print DATA "$eaddr\n";
		}
	close (DATA);
	
	open(OPTOUT, ">$optout") || die "Cannot write to $optout, because: $!\n";
	foreach $optoutline (@optout_array) { chomp($optoutline);
		@opoutc = split('\|', "$optoutline");
		if ((lc($opoutc[1]) eq "$eaddr") && ($opoutc[2] eq "$news_list")) { 
		next; 
		}
		else {
		print OPTOUT "$optoutline\n";
		}
	}
	close(OPTOUT);

unlink ($lockfile);
}
	
sub unsub {
while (-e $lockfile) {}
open(LOCK,">$lockfile") || die "Cannot create $!\n";
print LOCK "$time"; close(LOCK);
chmod 0666, "$lockfile";
	
	open(DATA, "$database/$news_list")|| die "Cannot open $database/$news_list because: $!";
	@array = <DATA>; close (DATA);
	
	open(DATA, ">$database/$news_list")|| die "Cannot open $database/$news_list because: $!";
	foreach $usersx (@array) {chomp($usersx); $hmny = ($usersx =~ tr/\,/\,/); $nameoutx = "";
			if ($hmny eq "1") {
			($nameout, $users) = split(',', $usersx, 2);
			}
			else {
			$users = "$usersx";
			}
		$eaddrf = lc($users);
		$eaddrf =~ s/\s//g;
		if ($eaddrf eq "$eaddr"){
		$nameoutx = "$nameout";
		next;
		}
		else {
		print DATA "$usersx\n";
		}
	}
	close (DATA);
	open(OPTOUT, ">>$optout") || die "Cannot write to $optout, because: $!\n";
	print OPTOUT "$nameoutx|$eaddr|$news_list|$recnum|$date\n"; close(OPTOUT);

unlink ($lockfile);
}

sub mail_notice {
	if ($mailerdaemon eq "1") {
	$lstaddrs = "$emailto";
	}
	else {
	$lstaddrs = "$ol[1] <$ol[2]>";
	}
	
	if ($smtpserver =~ /\w/) {
	$smtp = Net::SMTP->new($smtpserver);
		$smtp->mail($bouncereturn);
		$smtp->to($email);
		$smtp->data();
		$smtp->datasend("Reply-To: $lstaddrs\n");
		$smtp->datasend("From: $lstaddrs\n");
		$smtp->datasend("To: $name <$email>\n");
		$smtp->datasend("X-SimpleMail: xloop\n");
		$smtp->datasend("Subject: Error: SimpleMail was not successful with your request.\n");
		$smtp->datasend("\n");
		$smtp->datasend("Hello $name,\n\n");
		$smtp->datasend("Sorry, I could not perform the action requested because of the following reason.\n\n");
		$smtp->datasend("$bad_addr\n\n");
		$smtp->datasend("Date action occured: $date\n\n");
		$smtp->dataend();
	$smtp->quit;
	}
	else {
	open (MAIL, "|$mailprog -oi -t");
	
	   print MAIL "Reply-to: $lstaddrs\n";
	   print MAIL "From: $lstaddrs\n";
	   print MAIL "To: $name <$email>\n";
	   print MAIL "X-SimpleMail: xloop\n";
	   print MAIL "Subject: Error: SimpleMail was not successful with your request.\n\n";
	   print MAIL "Hello $name,\n\n";
	   print MAIL "Sorry, I could not perform the action requested because of the following reason.\n\n";
	   print MAIL "$bad_addr\n\n";
	   print MAIL "Date action occured: $date\n\n";
	   
	close (MAIL);
	}
	$bad_addr_flat = "$bad_addr"; $bad_addr_flat =~ s/\n+/ /g;
	&log_event("ERROR: Email Post: $bad_addr_flat, Name: $name, Email Address: $email, IP Address: $recnum, Date: $date");

exit;
}

sub get_info {
	foreach $line (@orgmail) {
		if ($line !~ /\w/) { last; }
		else {
		push (@header, $line);
		}
	}
	
	foreach $each (@orgmail){
		if ($each =~ s/X-SimpleMail: //){
			$xmailer = $each; chomp($xmailer);
			last;
		}
	}
	
	$flag = "0";
	foreach $each (@header){
		if ($each =~ s/Reply-To: //){
			$flag = "1";
			$reply = $each; chomp($reply);
			last;
		}
	}
	
	if ($flag eq "0") {
		foreach $each (@header){
			if ($each =~ s/From: //){
				$reply = $each; chomp($reply);
				last;
			}
		}
	}
	
	foreach $each (@header){
		if ($each =~ s/To: //){
			$to = $each; chomp($to);
			last;
		}
	}
	
	foreach $each (@header){
		if ($each =~ s/Received: //){
			$rec = $each; chomp($rec);
			last;
		}
	}
	
	foreach $each (@header){
		if ($each =~ s/Subject: //){
			$subject = $each; chomp($subject);
			last;
		}
	}
	
	if (($reply =~ /<|\(/) && ($reply =~ />|\)/)) {
		$reply =~ s/\(/\</g; $reply =~ s/\)/\>/g;
		($name, $email)=split(/</, $reply, 2);
		$email =~ s/>|\s+//;
		$name =~ s/\"|\s+$//g;
		if ($email !~ /\w/) {
		$email = "$name";
		}
	}
	else {
	$email = "$reply";
	$name = "Friend";
	}
	
	if (($to =~ /<|\(/) && ($to =~ />|\)/)) {
		$to =~ s/\(/\</g; $to =~ s/\)/\>/g;
		($nameto, $emailto)=split(/</, $to, 2);
		$emailto =~ s/>|\s+//;
		$nameto =~ s/\"|\s+$//g;
		if ($emailto !~ /\w/) {
		$emailto = "$nameto";
		}
	}
	else {
	$emailto = "$to";
	$nameto = "Friend";
	}

	
	$eaddr = lc($email);
	$subject =~ s/Re://; $subject =~ s/^\s+|\s+$//g; 
	$subject =~ s/\s+|\+/\ /g; $subject = lc($subject);
	($condition, $newslist) = split('\ ', "$subject", 2);
	
	$rec =~ /(\[\d+\D\d+\D\d+\D\d+\])/;
	$recnum = "$1";
	
}

sub log_event {
while (-e $loglock) {}
open(LOGLOCK,">$loglock") || die "Cannot create the lockfile for logging because: $!\n";
print LOGLOCK "$time"; close(LOGLOCK);
chmod 0666, "$loglock";

open(LOG, ">>$logs")|| die "Cannot write to the logfile file because: $!\n";
print LOG "$_[0]\n";
close (LOG);

unlink ($loglock);
}
